
import java.util.Random;


public class CandyGame {

	private /*@ spec_public @*/ int[] bambini;
	
	//public @invariant (\sum int i ; i >= 0 && i < 3 ; bambini[i] ) <= 9;
	//public @invariant bambini != null;
	
	//@ensures (\forall int i ; i >= 0 && i < 3 ; bambini[i] == 3 ); 
	public CandyGame() {
		bambini = new int[]{ 3 , 3 , 3 };

	}
	
	//NB	preferisco lasciare i metodi di controllo dentro le funzioni per poter
	//		eseguire le violazioni senza generare eccezioni
	
	//@requires !finito();
	//@requires child>=0;
	//@requires child<3;
	//@ensures \result ==> \old(bambini[0]) != bambini[0] || \old(bambini[1]) != bambini[1] || \old(bambini[2]) != bambini[2];
	public boolean move( int child ) {
		if(finito() || child<0 || child >= 3)
			return false;	
		if( bambini[child] >= 1 && bambini[child] != 2 ) {
			bambini[child] ++;
			return true;
		}
		if(bambini[(child+2)%3]>0) {
			bambini[(child+2)%3]--;
			bambini[child]++;
			return true;
		}
		if(bambini[(child+1)%3]>0) {
			bambini[(child+1)%3]--;
			bambini[(child+2)%3]++;
			return true;
		}
		return false;
	}
	
	//@ensures \result  ==> bambini[0] == 0 && bambini[1] == 0 &&	bambini[2] == 0;
	public /*@ pure @*/ boolean finito() {
		return	bambini[0] == 0 &&
				bambini[1] == 0 &&
				bambini[2] == 0 ;
	}
	
	//@diverges true;
	//@ensures finito();
	public void game() {
		Random r = new Random();
		while( !finito() ) {
			move(r.nextInt(3));
		}
	}
	
	
}
