
import nz.ac.waikato.modeljunit.Action;
import nz.ac.waikato.modeljunit.FsmModel;


public class CandyGame implements FsmModel{

	//array contenente le caramelle possedute da ogni bambino
	private int[] bambini;
	
	//inizializzo la struttura del gioco
	public CandyGame() {
		reset(true);
	}
	
	//metodo necessario ad effetturare il movimento
	//del bambino di posto child
	//N.B. vengono sfruttati i moduli per effettuare
	//i movimenti all'interno dell'array in modo sicuro
	private boolean move( int child ) {
		//prima di chiamare il metodo controllo che
		//il gioco non sia finito e l'input sia corretto
		if(finito() || child<0 || child >= 3)
			return false;	
		//punto 1
		if( bambini[child] >= 1 && bambini[child] != 2 ) {
			bambini[child] --;
			return true;
		}
		//punto 2.1
		if(bambini[(child+2)%3]>0) {
			bambini[(child+2)%3]--;
			bambini[child]++;
			return true;
		}
		//punto 2.2
		if(bambini[(child+1)%3]>0) {
			bambini[(child+1)%3]--;
			bambini[(child+2)%3]++;
			return true;
		}
		return false;
	}
	
	//metodo che segnala la fine del gioco
	private boolean finito() {
		return	bambini[0] == 0 &&
				bambini[1] == 0 &&
				bambini[2] == 0 ;
	}
	
	
	@Override
	public String toString() {
		String s = "";
		for (int i = 0; i < 3; i++) {
			s += bambini[i] ;
		}
		return s;
	}

	@Override
	public Object getState() {
		return toString();
	}

	@Override
	public void reset(boolean arg0) {
		bambini = new int[]{ 3 , 3 , 3 };
	}

	@Action
	public void move0() {
		move(0);
	}
	
	@Action
	public void move1() {
		move(1);
	}
	
	@Action
	public void move2() {
		move(2);
	}
	
	
	public boolean move0Guard() {
		if(finito())
			return false;	
		//punto 1
		if( bambini[0] >= 1 && bambini[0] != 2 ) {
			return true;
		}
		//punto 2.1
		if(bambini[2]>0) {
			return true;
		}
		//punto 2.2
		if(bambini[1]>0) {
			return true;
		}
		return false;
	}
	
	public boolean move1Guard() {
		if(finito())
			return false;	
		//punto 1
		if( bambini[1] >= 1 && bambini[1] != 2 ) {
			return true;
		}
		//punto 2.1
		if(bambini[0]>0) {
			return true;
		}
		//punto 2.2
		if(bambini[2]>0) {
			return true;
		}
		return false;
	}
	
	public boolean move2Guard() {
		if(finito())
			return false;	
		if(finito())
			return false;	
		//punto 1
		if( bambini[2] >= 1 && bambini[2] != 2 ) {
			return true;
		}
		//punto 2.1
		if(bambini[1]>0) {
			return true;
		}
		//punto 2.2
		if(bambini[0]>0) {
			return true;
		}
		return false;
	}
	
	
}
