import nz.ac.waikato.modeljunit.*;
import nz.ac.waikato.modeljunit.GreedyTester;
import nz.ac.waikato.modeljunit.coverage.CoverageMetric;
import nz.ac.waikato.modeljunit.coverage.StateCoverage;
import nz.ac.waikato.modeljunit.coverage.TransitionCoverage;

public class CandyGameTester
{
  public static void main(String args[])
  {
    CandyGame model = new CandyGame();
    GreedyTester tester = new GreedyTester(model);
    tester.setResetProbability(0.012);
    GraphListener graph = tester.buildGraph();


    CoverageMetric stateCoverage = new StateCoverage();
    tester.addCoverageMetric(stateCoverage);

    CoverageMetric transitionCoverage = new TransitionCoverage();
    tester.addCoverageMetric(transitionCoverage);

    tester.addListener(new VerboseListener());

    tester.generate(1000);

    System.out.println("State coverage = "+stateCoverage.toString());

    System.out.println("Transition coverage = "+transitionCoverage.toString());
  }
}
