import java.util.Arrays;
import java.util.Random;

public class CandyGame {

	// creo una istanza della classe random per avere un bambino diverso ogni
	// volta nel metodo game
	private static Random r = new Random();

	private int[] caramelle;

	CandyGame() {
		caramelle = new int[] { 3, 3, 3 };
	}

	/**
	 * 
	 * @param child
	 *            da 0 a 2 (rimappo i bambini da 0 a 2)
	 * @return
	 */
	boolean move(int child) {
		if (finito()  || child < 0 || child >= caramelle.length)
			return false;
		// 1. se ha almeno una caramella, ma non due, ne mangia una;
		if (caramelle[child] >= 1 && caramelle[child] != 2) {
			caramelle[child]--;
			return true;
		}
		int sx = (child + 1) % 3;
		int dx = (child + 2) % 3;
		// 2. se non ha alcuna caramella o ne ha due:
		// 1. se il suo vicino a destra ha almeno una caramella, ne ruba una ma
		// non la mangia immediatamente;
		if(caramelle[dx]>0) {
			caramelle[dx]--;
			caramelle[child]++;
			return true;
		}
		// 2. se il suo vicino a destra non ha alcuna caramella, controlla il
		// vicino a sinistra: se questo ha almeno una caramella, ne ruba una e
		// la da al suo vicino di destra.
		if(caramelle[sx]>0) {
			caramelle[sx]--;
			caramelle[dx]++;
			return true;
		}
		return false;
	}

	/**
	 * fa partire il gioco fino a quando  finito
	 */
	public void game() {
		while (!finito()) { // vado avanti finch il gioco continua
			// Returns a pseudorandom, uniformly distributed int value between 0
			// (inclusive) and the specified value (exclusive)
			int nextChild = r.nextInt(3); // genero il prossimo bambino
			move(nextChild); // eseguo l'azione sul bambino
		}
	}

	public boolean finito() {
		return caramelle[0] == 0 && caramelle[1] == 0 && caramelle[2] == 0;
	}

	// restituisce il mumero di caramelle per un bambino
	// sempre da 0 a 2
	public int getCaramelle(int child) {
		return caramelle[child];
	}

	int[] getCaramelle() {
		return caramelle;
	}

	@Override
	public String toString() {
		return Arrays.toString(caramelle);
	}

}
